// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from fuse_msgs:srv/SetGraph.idl
// generated code does not contain a copyright notice
#include "fuse_msgs/srv/detail/set_graph__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"

// Include directives for member types
// Member `graph`
#include "fuse_msgs/msg/detail/serialized_graph__functions.h"

bool
fuse_msgs__srv__SetGraph_Request__init(fuse_msgs__srv__SetGraph_Request * msg)
{
  if (!msg) {
    return false;
  }
  // graph
  if (!fuse_msgs__msg__SerializedGraph__init(&msg->graph)) {
    fuse_msgs__srv__SetGraph_Request__fini(msg);
    return false;
  }
  return true;
}

void
fuse_msgs__srv__SetGraph_Request__fini(fuse_msgs__srv__SetGraph_Request * msg)
{
  if (!msg) {
    return;
  }
  // graph
  fuse_msgs__msg__SerializedGraph__fini(&msg->graph);
}

bool
fuse_msgs__srv__SetGraph_Request__are_equal(const fuse_msgs__srv__SetGraph_Request * lhs, const fuse_msgs__srv__SetGraph_Request * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // graph
  if (!fuse_msgs__msg__SerializedGraph__are_equal(
      &(lhs->graph), &(rhs->graph)))
  {
    return false;
  }
  return true;
}

bool
fuse_msgs__srv__SetGraph_Request__copy(
  const fuse_msgs__srv__SetGraph_Request * input,
  fuse_msgs__srv__SetGraph_Request * output)
{
  if (!input || !output) {
    return false;
  }
  // graph
  if (!fuse_msgs__msg__SerializedGraph__copy(
      &(input->graph), &(output->graph)))
  {
    return false;
  }
  return true;
}

fuse_msgs__srv__SetGraph_Request *
fuse_msgs__srv__SetGraph_Request__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  fuse_msgs__srv__SetGraph_Request * msg = (fuse_msgs__srv__SetGraph_Request *)allocator.allocate(sizeof(fuse_msgs__srv__SetGraph_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(fuse_msgs__srv__SetGraph_Request));
  bool success = fuse_msgs__srv__SetGraph_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
fuse_msgs__srv__SetGraph_Request__destroy(fuse_msgs__srv__SetGraph_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    fuse_msgs__srv__SetGraph_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
fuse_msgs__srv__SetGraph_Request__Sequence__init(fuse_msgs__srv__SetGraph_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  fuse_msgs__srv__SetGraph_Request * data = NULL;

  if (size) {
    data = (fuse_msgs__srv__SetGraph_Request *)allocator.zero_allocate(size, sizeof(fuse_msgs__srv__SetGraph_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = fuse_msgs__srv__SetGraph_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        fuse_msgs__srv__SetGraph_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
fuse_msgs__srv__SetGraph_Request__Sequence__fini(fuse_msgs__srv__SetGraph_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      fuse_msgs__srv__SetGraph_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

fuse_msgs__srv__SetGraph_Request__Sequence *
fuse_msgs__srv__SetGraph_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  fuse_msgs__srv__SetGraph_Request__Sequence * array = (fuse_msgs__srv__SetGraph_Request__Sequence *)allocator.allocate(sizeof(fuse_msgs__srv__SetGraph_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = fuse_msgs__srv__SetGraph_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
fuse_msgs__srv__SetGraph_Request__Sequence__destroy(fuse_msgs__srv__SetGraph_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    fuse_msgs__srv__SetGraph_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
fuse_msgs__srv__SetGraph_Request__Sequence__are_equal(const fuse_msgs__srv__SetGraph_Request__Sequence * lhs, const fuse_msgs__srv__SetGraph_Request__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!fuse_msgs__srv__SetGraph_Request__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
fuse_msgs__srv__SetGraph_Request__Sequence__copy(
  const fuse_msgs__srv__SetGraph_Request__Sequence * input,
  fuse_msgs__srv__SetGraph_Request__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(fuse_msgs__srv__SetGraph_Request);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    fuse_msgs__srv__SetGraph_Request * data =
      (fuse_msgs__srv__SetGraph_Request *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!fuse_msgs__srv__SetGraph_Request__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          fuse_msgs__srv__SetGraph_Request__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!fuse_msgs__srv__SetGraph_Request__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `message`
#include "rosidl_runtime_c/string_functions.h"

bool
fuse_msgs__srv__SetGraph_Response__init(fuse_msgs__srv__SetGraph_Response * msg)
{
  if (!msg) {
    return false;
  }
  // success
  // message
  if (!rosidl_runtime_c__String__init(&msg->message)) {
    fuse_msgs__srv__SetGraph_Response__fini(msg);
    return false;
  }
  return true;
}

void
fuse_msgs__srv__SetGraph_Response__fini(fuse_msgs__srv__SetGraph_Response * msg)
{
  if (!msg) {
    return;
  }
  // success
  // message
  rosidl_runtime_c__String__fini(&msg->message);
}

bool
fuse_msgs__srv__SetGraph_Response__are_equal(const fuse_msgs__srv__SetGraph_Response * lhs, const fuse_msgs__srv__SetGraph_Response * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // success
  if (lhs->success != rhs->success) {
    return false;
  }
  // message
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->message), &(rhs->message)))
  {
    return false;
  }
  return true;
}

bool
fuse_msgs__srv__SetGraph_Response__copy(
  const fuse_msgs__srv__SetGraph_Response * input,
  fuse_msgs__srv__SetGraph_Response * output)
{
  if (!input || !output) {
    return false;
  }
  // success
  output->success = input->success;
  // message
  if (!rosidl_runtime_c__String__copy(
      &(input->message), &(output->message)))
  {
    return false;
  }
  return true;
}

fuse_msgs__srv__SetGraph_Response *
fuse_msgs__srv__SetGraph_Response__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  fuse_msgs__srv__SetGraph_Response * msg = (fuse_msgs__srv__SetGraph_Response *)allocator.allocate(sizeof(fuse_msgs__srv__SetGraph_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(fuse_msgs__srv__SetGraph_Response));
  bool success = fuse_msgs__srv__SetGraph_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
fuse_msgs__srv__SetGraph_Response__destroy(fuse_msgs__srv__SetGraph_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    fuse_msgs__srv__SetGraph_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
fuse_msgs__srv__SetGraph_Response__Sequence__init(fuse_msgs__srv__SetGraph_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  fuse_msgs__srv__SetGraph_Response * data = NULL;

  if (size) {
    data = (fuse_msgs__srv__SetGraph_Response *)allocator.zero_allocate(size, sizeof(fuse_msgs__srv__SetGraph_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = fuse_msgs__srv__SetGraph_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        fuse_msgs__srv__SetGraph_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
fuse_msgs__srv__SetGraph_Response__Sequence__fini(fuse_msgs__srv__SetGraph_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      fuse_msgs__srv__SetGraph_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

fuse_msgs__srv__SetGraph_Response__Sequence *
fuse_msgs__srv__SetGraph_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  fuse_msgs__srv__SetGraph_Response__Sequence * array = (fuse_msgs__srv__SetGraph_Response__Sequence *)allocator.allocate(sizeof(fuse_msgs__srv__SetGraph_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = fuse_msgs__srv__SetGraph_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
fuse_msgs__srv__SetGraph_Response__Sequence__destroy(fuse_msgs__srv__SetGraph_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    fuse_msgs__srv__SetGraph_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
fuse_msgs__srv__SetGraph_Response__Sequence__are_equal(const fuse_msgs__srv__SetGraph_Response__Sequence * lhs, const fuse_msgs__srv__SetGraph_Response__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!fuse_msgs__srv__SetGraph_Response__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
fuse_msgs__srv__SetGraph_Response__Sequence__copy(
  const fuse_msgs__srv__SetGraph_Response__Sequence * input,
  fuse_msgs__srv__SetGraph_Response__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(fuse_msgs__srv__SetGraph_Response);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    fuse_msgs__srv__SetGraph_Response * data =
      (fuse_msgs__srv__SetGraph_Response *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!fuse_msgs__srv__SetGraph_Response__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          fuse_msgs__srv__SetGraph_Response__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!fuse_msgs__srv__SetGraph_Response__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `info`
#include "service_msgs/msg/detail/service_event_info__functions.h"
// Member `request`
// Member `response`
// already included above
// #include "fuse_msgs/srv/detail/set_graph__functions.h"

bool
fuse_msgs__srv__SetGraph_Event__init(fuse_msgs__srv__SetGraph_Event * msg)
{
  if (!msg) {
    return false;
  }
  // info
  if (!service_msgs__msg__ServiceEventInfo__init(&msg->info)) {
    fuse_msgs__srv__SetGraph_Event__fini(msg);
    return false;
  }
  // request
  if (!fuse_msgs__srv__SetGraph_Request__Sequence__init(&msg->request, 0)) {
    fuse_msgs__srv__SetGraph_Event__fini(msg);
    return false;
  }
  // response
  if (!fuse_msgs__srv__SetGraph_Response__Sequence__init(&msg->response, 0)) {
    fuse_msgs__srv__SetGraph_Event__fini(msg);
    return false;
  }
  return true;
}

void
fuse_msgs__srv__SetGraph_Event__fini(fuse_msgs__srv__SetGraph_Event * msg)
{
  if (!msg) {
    return;
  }
  // info
  service_msgs__msg__ServiceEventInfo__fini(&msg->info);
  // request
  fuse_msgs__srv__SetGraph_Request__Sequence__fini(&msg->request);
  // response
  fuse_msgs__srv__SetGraph_Response__Sequence__fini(&msg->response);
}

bool
fuse_msgs__srv__SetGraph_Event__are_equal(const fuse_msgs__srv__SetGraph_Event * lhs, const fuse_msgs__srv__SetGraph_Event * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // info
  if (!service_msgs__msg__ServiceEventInfo__are_equal(
      &(lhs->info), &(rhs->info)))
  {
    return false;
  }
  // request
  if (!fuse_msgs__srv__SetGraph_Request__Sequence__are_equal(
      &(lhs->request), &(rhs->request)))
  {
    return false;
  }
  // response
  if (!fuse_msgs__srv__SetGraph_Response__Sequence__are_equal(
      &(lhs->response), &(rhs->response)))
  {
    return false;
  }
  return true;
}

bool
fuse_msgs__srv__SetGraph_Event__copy(
  const fuse_msgs__srv__SetGraph_Event * input,
  fuse_msgs__srv__SetGraph_Event * output)
{
  if (!input || !output) {
    return false;
  }
  // info
  if (!service_msgs__msg__ServiceEventInfo__copy(
      &(input->info), &(output->info)))
  {
    return false;
  }
  // request
  if (!fuse_msgs__srv__SetGraph_Request__Sequence__copy(
      &(input->request), &(output->request)))
  {
    return false;
  }
  // response
  if (!fuse_msgs__srv__SetGraph_Response__Sequence__copy(
      &(input->response), &(output->response)))
  {
    return false;
  }
  return true;
}

fuse_msgs__srv__SetGraph_Event *
fuse_msgs__srv__SetGraph_Event__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  fuse_msgs__srv__SetGraph_Event * msg = (fuse_msgs__srv__SetGraph_Event *)allocator.allocate(sizeof(fuse_msgs__srv__SetGraph_Event), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(fuse_msgs__srv__SetGraph_Event));
  bool success = fuse_msgs__srv__SetGraph_Event__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
fuse_msgs__srv__SetGraph_Event__destroy(fuse_msgs__srv__SetGraph_Event * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    fuse_msgs__srv__SetGraph_Event__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
fuse_msgs__srv__SetGraph_Event__Sequence__init(fuse_msgs__srv__SetGraph_Event__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  fuse_msgs__srv__SetGraph_Event * data = NULL;

  if (size) {
    data = (fuse_msgs__srv__SetGraph_Event *)allocator.zero_allocate(size, sizeof(fuse_msgs__srv__SetGraph_Event), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = fuse_msgs__srv__SetGraph_Event__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        fuse_msgs__srv__SetGraph_Event__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
fuse_msgs__srv__SetGraph_Event__Sequence__fini(fuse_msgs__srv__SetGraph_Event__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      fuse_msgs__srv__SetGraph_Event__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

fuse_msgs__srv__SetGraph_Event__Sequence *
fuse_msgs__srv__SetGraph_Event__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  fuse_msgs__srv__SetGraph_Event__Sequence * array = (fuse_msgs__srv__SetGraph_Event__Sequence *)allocator.allocate(sizeof(fuse_msgs__srv__SetGraph_Event__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = fuse_msgs__srv__SetGraph_Event__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
fuse_msgs__srv__SetGraph_Event__Sequence__destroy(fuse_msgs__srv__SetGraph_Event__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    fuse_msgs__srv__SetGraph_Event__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
fuse_msgs__srv__SetGraph_Event__Sequence__are_equal(const fuse_msgs__srv__SetGraph_Event__Sequence * lhs, const fuse_msgs__srv__SetGraph_Event__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!fuse_msgs__srv__SetGraph_Event__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
fuse_msgs__srv__SetGraph_Event__Sequence__copy(
  const fuse_msgs__srv__SetGraph_Event__Sequence * input,
  fuse_msgs__srv__SetGraph_Event__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(fuse_msgs__srv__SetGraph_Event);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    fuse_msgs__srv__SetGraph_Event * data =
      (fuse_msgs__srv__SetGraph_Event *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!fuse_msgs__srv__SetGraph_Event__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          fuse_msgs__srv__SetGraph_Event__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!fuse_msgs__srv__SetGraph_Event__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
